const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const equipes_trabalho = sequelize.define(
    'equipes_trabalho',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      nome_equipe: {
        type: DataTypes.TEXT,
      },

      tipo: {
        type: DataTypes.ENUM,

        values: ['Copasa', 'Subcontratada'],
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  equipes_trabalho.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    db.equipes_trabalho.hasMany(db.membros_equipe, {
      as: 'membros_equipe_equipe',
      foreignKey: {
        name: 'equipeId',
      },
      constraints: false,
    });

    //end loop

    db.equipes_trabalho.belongsTo(db.obras, {
      as: 'obra',
      foreignKey: {
        name: 'obraId',
      },
      constraints: false,
    });

    db.equipes_trabalho.belongsTo(db.clientes, {
      as: 'clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.equipes_trabalho.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.equipes_trabalho.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return equipes_trabalho;
};
